<template>
  <div class="container">
    <h3>Estás abordando esta barca:</h3>
    <barca v-if="barca" :barca="barca" />
    <p v-else>cargando...</p>
    <custom-button @click="abordarBarca" :loading="loading">
      Abordar barca
    </custom-button>
  </div>
</template>

<script>
import { mapState } from 'vuex'

import Barca from '@/components/Barca'
import CustomButton from '@/components/Button.vue'

export default {
  name: 'AbordarBarca',
  components: { Barca, CustomButton },
  data() {
    return { loading: false, error: null }
  },
  computed: {
    ...mapState(['barcas']),
    barcaId() {
      return this.$route.params.id
    },
    barca() {
      return this.barcas.find(barca => barca.id == this.barcaId)
    },
  },
  methods: {
    abordarBarca() {
      this.loading = true
      this.$store
        .dispatch('abordarBarca', { barcaId: this.barcaId })
        .then(() => {
          this.$router.push(`/barcas/${this.barcaId}`)
        })
        .catch(error => (this.error = error))
        .finally(() => (this.loading = false))
    },
    refrescar() {
      return this.$store.dispatch('conseguirBarca', {
        barcaId: this.barcaId,
      })
    },
  },
  mounted() {
    this.refrescar()
  },
}
</script>

<style lang="sass" scoped>
// ocultar los botones de el componente de barca
.barca .buttons
  display: none
</style>
